import { Input, Injectable, ViewChild } from '@angular/core';
import * as _ from 'lodash-es';
import { PrismService } from './prism.service';
export class PrismClass {
    constructor(prismService) {
        this.prismService = prismService;
        this._change = false;
        this._async = false;
    }
    set change(value) {
        this._change = value;
    }
    get change() {
        return this._change;
    }
    set async(value) {
        this._async = value;
    }
    get async() {
        return this._async;
    }
    set callback(value) {
        this._callback = value;
    }
    get callback() {
        return this._callback;
    }
    set code(value) {
        this._code = value;
    }
    get code() {
        return this._code;
    }
    set hooks(value) {
        this._hooks = value;
        if (value instanceof Object) {
            _.forEach(value, (element, key) => {
                this.prismService.hooks().add(key, element);
            });
        }
    }
    get hooks() {
        return this._hooks;
    }
    set language(value) {
        if (value) {
            if (typeof (value) === 'string') {
                this._language = value;
            }
            else {
                throw new Error(`Property \`language\` should be \`string\` instead of provided \`${typeof (value)}\``);
            }
        }
        else {
            throw new Error('Missing property `language`.');
        }
    }
    ;
    get language() {
        return this._language;
    }
    set interpolation(value) {
        this._interpolation = value;
    }
    get interpolation() {
        return this._interpolation;
    }
    onChanges(prop, changes) {
        if (changes) {
            _.each(changes, (value, key) => {
                if (prop instanceof Array) {
                    _.each(prop, (propName) => {
                        if (key === propName) {
                            if (changes[key].currentValue !== changes[key].previousValue) {
                                this.change = true;
                            }
                        }
                    });
                }
                else {
                    switch (key) {
                        case prop:
                            if (changes[key].currentValue !== changes[key].previousValue) {
                                this.change = true;
                            }
                            break;
                    }
                }
            });
        }
    }
}
PrismClass.decorators = [
    { type: Injectable },
];
PrismClass.ctorParameters = () => [
    { type: PrismService, },
];
PrismClass.propDecorators = {
    'async': [{ type: Input, args: ['async',] },],
    'callback': [{ type: Input, args: ['callback',] },],
    'code': [{ type: Input, args: ['code',] },],
    'hooks': [{ type: Input, args: ['hooks',] },],
    'language': [{ type: Input, args: ['language',] },],
    'interpolation': [{ type: Input, args: ['interpolation',] },],
    'codeElementRef': [{ type: ViewChild, args: ['codeElementRef',] },],
};
//# sourceMappingURL=prism.class.js.map