import { ChangeDetectionStrategy, Component, ViewEncapsulation } from '@angular/core';
import { PrismClass } from './prism.class';
import { PrismService } from './prism.service';
export class PrismComponent extends PrismClass {
    constructor(prismService) {
        super(prismService);
        this.prismService = prismService;
    }
    ngAfterViewChecked() {
        if (this.change === true) {
            this.prismService.highlight(this.codeElementRef, {
                async: this.async,
                callback: this.callback,
                code: this.code,
                interpolation: this.interpolation
            });
            this.change = false;
        }
    }
    ngOnChanges(changes) {
        this.onChanges(['code', 'language'], changes);
    }
}
PrismComponent.decorators = [
    { type: Component, args: [{
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                selector: 'prism-highlight',
                template: `<pre class="language-{{language}}" *ngIf="language">
  <code #codeElementRef class="language-{{language}}">
    <ng-content *ngIf="!code"></ng-content>
  </code>
</pre>`,
                providers: [PrismService]
            },] },
];
PrismComponent.ctorParameters = () => [
    { type: PrismService, },
];
//# sourceMappingURL=prism.component.js.map